QGIS Application - Bug report #739
GRASS Shell non-functional in OS X
2007-07-14 08:07 PM - John Tull

Status: Closed

Priority: Low

Assignee: Tom Elwertowski

Category: GRASS

Affected QGIS version: Regression?: No
Operating System: OS X Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 10798
Description

The GRASS Shell impementation in OS X is non-functional. Oddly, trying to type in commands results in keyboard shortcuts being
executed for qgis. For instance, trying to type v.in.ogr stops as soon as the v key is hit. The add vector layer dialog comes up.

I do not know if this is a qgis or gt problem. Perhaps there is a method to turn off keyboard shortcuts? If so, | would recommend having
them off by default, or at least requiring some form of modifier like the option key.

This happens in 0.8.1 and 0.9.

Associated revisions

Revision dc947aea - 2009-08-15 09:19 PM - William Kyngesburye

don't use plain keys for shortcuts - against common Ul guidelines (OSX at least), and registers while in GRASS shell (fix #739)

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@11389 c¢8812cc2-4d05-0410-92ff-de0c093fc19¢c

Revision 269da46 - 2009-08-15 09:19 PM - William Kyngesburye

don't use plain keys for shortcuts - against common Ul guidelines (OSX at least), and registers while in GRASS shell (fix #739)

git-svn-id: http://svn.osgeo.org/qgis/trunk@11389 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2007-08-14 08:45 PM - John Tull

Updated to reflect this issued effects v. 0.9.

#2 - 2007-08-15 07:58 PM - John Tull
| tested the functionality of the GRASS shell with single-key shortcuts edited out of ggisapp.cpp (i.e., commented out "V", "N", ".", etc.) on OS X with the 0.9
source. Unfortunately, it is not so simple. The shell itself does not handle keyboard inputs properly, and there are also drawing/refresh problems (e.g.,

cursor disappears after sending a return keystroke).

| am changing this to a plugin defect rather than a gui defect.
#3 - 2007-11-29 02:12 AM - Tim Sutton

Hi

For me on OSX building QGIS 0.9.1trunk clicking the grass shell in the tool box does not open any GRASS shell at all.

(Sorry to take so Ing to respond to your email John)

Regards

Tim

#4 - 2007-12-01 12:05 AM - Tom Elwertowski

Observations:

The initial shell prompt does not appear.

The shell subprocess dies at the first keystroke and the plugin doesn't notice.

Action keys are processed be qgis because the shell subprocess is no longer there.

The connectivity between the shell subprocess and the plugin probably needs some Mac customization. More investigation is needed.
#5 - 2007-12-02 08:54 PM - Tom Elwertowski

- Resolution set to fixed
- Status changed from Open to Closed

Fixed by commit:c38a9¢c22 (SVN r7708).

#6 - 2009-04-30 07:36 AM - John Tull
- Resolution deleted (fixed)
- Status changed from Closed to Feedback

The new grass plugin has caused this problem to return. Same behavior as before.

#7 - 2009-05-04 01:06 PM - John Tull

The new ability to change keyboard shortcuts provides a workaround to this problem. | would suggest that the defaults for OS X should be changed to

meta+Letter, e.g., meta+v for add vector layer. Otherwise, we need to come up with a proper solution or this will create many problems for OS X users.

#8 - 2009-07-15 08:50 AM - William Kyngesburye

Currently in Qgis 1.1.0 for me, when the GRASS shell is active, shortcuts are ignored. Though the menu still hilites briefly, which is distracting.

| would suggest, as John does, to not use plain keystrokes as shortcuts. This goes against OSX conventions (and guidelines?), and possibly Windows and

Linux conventions as well. Since there appears to be some overlap in shortcuts vs. some that use platform standards or other meta keys (cmd-P for print,
P for Properties), other modifier keys could also be used in combination with the platform meta (cmd-shift-P).
#9 - 2009-08-11 09:58 AM - Paolo Cavallini

| would suggest to change the shortcuts and close this bug. Please OSXers check this out

#10 - 2009-08-13 11:35 AM - William Kyngesburye

Are you saying change shortcuts to use meta keys for all systems (it would be good to be consistent across platforms), or create a special case set of
shortcuts for OSX?

Either way, | don't know how/where to do this.

#11 - 2009-08-14 07:22 AM - William Kyngesburye

OK, | found where the shortcuts are initially set in ggisapp.cpp.

| checked all the single-letter shortcuts and all but one can be changed to meta+shift+letter without conflicts. Layer->Show all layers would conflict with

Save As. ..hmm, maybe U for unhide.

I'll do this later, if | don't hear any better suggestions.

#12 - 2009-08-15 12:26 PM - William Kyngesburye

- Status changed from Feedback to Closed

- Resolution set to fixed

Applied in commit:f269da46 (SVN r11390).

There was also an anomaly with the + and - keys (used in zoom in/out and add/remove all from overview). + only registers with shift=, so there is no
distinction between ctrl+ and shift-ctrl+. So | removed the ctrl +/- shortcuts from the add/remove all from overview actions and used ctrl +/- for zooming.
